library(data.table)
library(jsonlite)
dt = data.table(fromJSON("~/Downloads/HM_responses_08_08.json", flatten=TRUE))
key = data.table(fromJSON("~/Downloads/answerKey.json", flatten=FALSE))

results = data.table(id=dt$hash_id)

found = function(u,k) {
  f = 0
  if (nrow(u) > 0) {
    for(i in 1:nrow(u)) { 
      count = 0
      for(j in 1:nrow(k)) {
        dx = u[i,]$x - k[j,]$x
        dy = u[i,]$y - k[j,]$y
        if (sqrt(dx*dx+dy*dy) <= 0.026) { f = f+1 
                                         count = count + 1 }
      }
      if (count > 1) print("busted")
    }
  }
  return(f)
}


parse = function() {
  results = data.table(hash_id=dt$hash_id, group=dt$question_order, c1=0, c2=0, c3=0, g1=0, g2=0, g3=0, c1f=0, c2f=0, c3f=0, g1f=0, g2f=0, g3f=0)
  for (id in results$hash_id) {
    print(id)
    if (dt[hash_id==id]$question_order == 1) {
      k = data.table(x = unlist(key[1]$X6.true_x), 
                     y = unlist(key[1]$X6.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.6.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.6.figures.y)+ 0.075)

      results[hash_id==id]$c1 = found(u,k)
      results[hash_id==id]$c1f = nrow(u) - results[hash_id==id]$c1
      
      k = data.table(x = unlist(key[1]$X7.true_x), 
                     y = unlist(key[1]$X7.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.7.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.7.figures.y)+ 0.075)
      
      results[hash_id==id]$c2 = found(u,k)
      results[hash_id==id]$c2f = nrow(u) - results[hash_id==id]$c2
      
      k = data.table(x = unlist(key[1]$X8.true_x), 
                     y = unlist(key[1]$X8.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.8.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.8.figures.y) + 0.075)
      
      results[hash_id==id]$c3 = found(u,k)
      results[hash_id==id]$c3f = nrow(u) - results[hash_id==id]$c3
      print(paste("c", nrow(u), results[hash_id==id]$c3, results[hash_id==id]$c3f))
      
      k = data.table(x = unlist(key[1]$X13.true_x), 
                     y = unlist(key[1]$X13.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.13.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.13.figures.y)+ 0.075)
      
      results[hash_id==id]$g1 = found(u,k)
      results[hash_id==id]$g1f = nrow(u) - results[hash_id==id]$g1
      print(paste("g", nrow(u), results[hash_id==id]$g1, results[hash_id==id]$g1f))
      
      k = data.table(x = unlist(key[1]$X14.true_x), 
                     y = unlist(key[1]$X14.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.14.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.14.figures.y)+ 0.075)
      
      results[hash_id==id]$g2 = found(u,k)
      results[hash_id==id]$g2f = nrow(u) - results[hash_id==id]$g2
      
      k = data.table(x = unlist(key[1]$X15.true_x), 
                     y = unlist(key[1]$X15.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.15.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.15.figures.y)+ 0.075)
      
      results[hash_id==id]$g3 = found(u,k)
      results[hash_id==id]$g3f = nrow(u) - results[hash_id==id]$g3

    } else {
      k = data.table(x = unlist(key[2]$X6.true_x), 
                     y = unlist(key[2]$X6.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.6.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.6.figures.y)+ 0.075)

      results[hash_id==id]$g1 = found(u,k)
      results[hash_id==id]$g1f = nrow(u) - results[hash_id==id]$g1
      print(paste("g", nrow(u), results[hash_id==id]$g1, results[hash_id==id]$g1f))
      
      k = data.table(x = unlist(key[2]$X7.true_x), 
                     y = unlist(key[2]$X7.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.7.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.7.figures.y)+ 0.075)
  
      results[hash_id==id]$g2 = found(u,k)
      results[hash_id==id]$g2f = nrow(u) - results[hash_id==id]$g2
      
      k = data.table(x = unlist(key[2]$X8.true_x), 
                     y = unlist(key[2]$X8.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.8.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.8.figures.y)+ 0.075)
      
      results[hash_id==id]$g3 = found(u,k)
      results[hash_id==id]$g3f = nrow(u) - results[hash_id==id]$g3
      
      k = data.table(x = unlist(key[2]$X13.true_x), 
                     y = unlist(key[2]$X13.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.13.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.13.figures.y)+ 0.075)

      results[hash_id==id]$c1 = found(u,k)
      results[hash_id==id]$c1f = nrow(u) - results[hash_id==id]$c1
      print(paste("c", nrow(u), results[hash_id==id]$c1, results[hash_id==id]$c1f))
      
      k = data.table(x = unlist(key[2]$X14.true_x), 
                     y = unlist(key[2]$X14.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.14.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.14.figures.y)+ 0.075)
      
      results[hash_id==id]$c2 = found(u,k)
      results[hash_id==id]$c2f = nrow(u) - results[hash_id==id]$c2
      
      k = data.table(x = unlist(key[2]$X15.true_x), 
                     y = unlist(key[2]$X15.true_y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.15.figures.x),
                     y = 0.9 * unlist(dt[hash_id==id]$response_data.15.figures.y) + 0.075)
      
      results[hash_id==id]$c3 = found(u,k)
      results[hash_id==id]$c3f = nrow(u) - results[hash_id==id]$c3
    }
  }
  results[, g:=g1+g2+g3]
  results[, gf:=g1f+g2f+g3f]
  
  results[, c:=c1+c2+c3]
  results[, cf:=c1f+c2f+c3f]
  
  return(results)
}

s = 1

parse_selections = function() {
  results = data.table(x=numeric(), y=numeric())
  for (id in dt$hash_id) {
    print(id)
    if (dt[hash_id==id]$question_order == 1) {
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.6.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.6.figures.y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.7.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.7.figures.y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.8.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.8.figures.y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.13.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.13.figures.y))
      
      results = rbind(results, u);
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.14.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.14.figures.y))
      
      results = rbind(results, u);
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.15.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.15.figures.y))
      
      results = rbind(results, u);
      
      
    } else {
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.6.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.6.figures.y))
      
      results = rbind(results, u);
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.7.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.7.figures.y))
      
      results = rbind(results, u);
    
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.8.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.8.figures.y))
      
      results = rbind(results, u);
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.13.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.13.figures.y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.14.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.14.figures.y))
      
      u = data.table(x = unlist(dt[hash_id==id]$response_data.15.figures.x),
                     y = s * unlist(dt[hash_id==id]$response_data.15.figures.y))
      
    }
  }

  return(results)
}